package de.j32.jpim;

import java.io.IOException;

import de.j32.jpim.conduit.Conduit;
import de.j32.jpim.conduit.ConduitException;
import de.j32.jpim.conduit.Exporter;
import de.j32.jpim.conduit.Importer;
import de.j32.jpim.data.EntryConsumer;
import de.j32.jpim.data.EntryProducer;
import de.j32.util.Util;

public class Data
{
    public static void transfer(EntryProducer producer, EntryConsumer consumer)
    {
        // TODO: It would be more 'beautiful' to have the EntryProducer be an
        // Iterable, but this is simpler ...
        producer.sendTo(consumer);
    }

    public static void transfer(Conduit conduit, EntryConsumer consumer) throws ConduitException,
            IOException
    {
        Importer importer = null;
        try {
            importer = conduit.importer();
            transfer(importer, consumer);
            importer.close();
            importer = null;
        }
        finally {
            Util.nothrowClose(importer);
        }
    }

    public static void transfer(EntryProducer producer, Conduit conduit) throws ConduitException,
            IOException
    {
        Exporter exporter = null;
        try {
            exporter = conduit.exporter();
            transfer(producer, exporter);
            exporter.close();
            exporter = null;
        }
        finally {
            Util.nothrowClose(exporter);
        }
    }
}
